#include <iostream>

extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

lua_State* ls;

lua_State* lua_init()
{
    if (ls == NULL) {
        ls = luaL_newstate();
        luaL_openlibs(ls);
    }
    return ls;
}

int c_sum(lua_State* l)
{
    int result;
    const int num1 = lua_tointeger(l, 1);
    const int num2 = lua_tointeger(l, 2);
    result = num1 + num2;
    lua_pushinteger(l, result);
    return 1;
}

int main(int argc,char** argv)
{
    std::cout<< "lua call c function" <<std::endl;
    lua_init();

    lua_register(ls, "my_sum", &c_sum);
    return 0;
}