#include <iostream>

extern "C" {
#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>
}

//lua_registerĵ3Ҫint ()(lua_State*)͵ĺָ
int c_sum(lua_State* l)
{
    long long result;
    const long long num1 = lua_tointeger(l, 1);
    const long long num2 = lua_tointeger(l, 2);
    result = num1 + num2;
    std::cout<< num1 << "+" << num2 << "=" << result << std::endl;
    lua_pushinteger(l, result);
    return 1;
}

int main(int argc, char **argv) {
    int r;
    const  char* err;
    lua_State* ls;

    ls = luaL_newstate();
    luaL_openlibs(ls);
    //עc_sumluaƸΪmy_sum
    lua_register(ls, "my_sum", &c_sum);
    //luaű
    r = luaL_loadfile(ls, argv[1]);
    if (r) {
        err = lua_tostring(ls, -1);
        std::cout<< "lua err1: " << err << std::endl;
        return 1;
    }
    //luaű
    r = lua_pcall(ls, 0, 0, 0);
    if (r) {
        err = lua_tostring(ls, -1);
        if (err) {
            std::cout << "lua err2: " << err << std::endl;
        }
        return  2;
    }
    lua_close(ls);
    return 0;
}